template <typename T>
void DataSourceManager::RegisterDataSource()
{
	DataSourcePtr dataSource = new T();
	Mortar::AsciiString name = dataSource->GetName();
	DataSourceMap::const_iterator it = m_dataSources.find(name);

	if (it == m_dataSources.end())
	{
		m_dataSources[name].SetPtr(dataSource);
	}
	else
	{
		ASSERT_MSG(false, "There is already a datasource in the manager with name '%s'", name.c_str());
	}
}

template <typename T>
DataSourcePtr DataSourceManager::GetDataSourceProxy()
{
	return GetDataSourceProxy(T::DataSourceName);
}

struct FindBinderByTypeId
{
	FindBinderByTypeId(u32 id)
		: m_id(id) {}
	bool operator()(const ComponentBinderPtr& binder)
	{
		ASSERT(binder != NULL);
		return binder.GetPtr()->GetComponentType() == m_id;
	}
	u32 m_id;
};

template <typename T>
void DataSourceManager::RegisterComponentDataBinder()
{
	ComponentBinderPtr binder;
	binder.SetPtr(new T());

	if (std::find_if(m_dataBinders.begin(), m_dataBinders.end(), FindBinderByTypeId(binder->GetComponentType())) == m_dataBinders.end())
	{
		m_dataBinders.push_back(binder);
	}
}