// template implementation
template <class T>
T Effect::Animation::Interpolate(const Mortar::AsciiString &interpolationType, T v1, T v2, float time)
{
	static float s_pi = 3.141592f;
	static float s_piOn2 = s_pi * 0.5f;

	if (interpolationType.EqualsI("sin") == true)
	{
		T diff = v2 - v1;
		time *= s_piOn2;
		
		return v1 + (diff * sinf(time));
	}
	else if (interpolationType.EqualsI("cos") == true)
	{
		T diff = v2 - v1;
		time *= s_piOn2;
		
		return v1 + (diff * (1.0f - cosf(time)));
	}
	
	// default to linear
	return v1 + ((v2 - v1) * time);
}


template <class T>
void Effect::SetVariableFromParam(T &var, const Mortar::AsciiString &paramKey, ParamMap &params)
{
	ParamMap::iterator param = params.find(paramKey);
	if (param != params.end())
	{
		SetVariableFromString(var, param->second);
	}
}

template <class T>
bool Effect::SetVariableIfDefault(T &var, const Mortar::AsciiString &valueString, T def)
{
	if (valueString.Equals("*") == true)
	{
		var = def;
		return true;
	}

	return false;
}